pub struct MdTransform;

impl MdTransform {
    pub fn transform(markdown: String) -> String {
        let mut lines = markdown
            .split("\n")
            .map(|x| x.to_string().chars().collect::<Vec<char>>())
            .collect::<Vec<Vec<char>>>();

        Self::trans(&mut lines);

        "".to_string()
    }

    fn trans(markdownLines: &mut Vec<Vec<char>>) {
        let mut notation: Vec<Vec<char>> = Vec::new();
        let mut mdLinesIter = markdownLines.into_iter();

        while let Some(current) = mdLinesIter.next() {}
    }

    fn transformLine(line: &mut [char]) -> String {
        match line {
            ['#', rest @ ..] => {
                let mut nrOfHashtags = 0;
                for i in rest {
                    if *i != '#' {
                        break;
                    }
                    nrOfHashtags += 1;
                }
                Self::transformLine(&mut rest[nrOfHashtags..])
            }
            ['-', '-', '-', rest @ ..] => {
                let validLine = rest.iter().fold(true, |x, y| x && *y == '-');
                if validLine {
                    "<hr>".to_string()
                } else {
                    let mut res = "<p>---".to_string();
                    res.push_str(&rest.iter().collect::<String>());
                    res
                }
            }
            ['`', '`', '`', languageName @ ..] => {
                let mut linesInBlock = Vec::new();

                for z in mdLinesIter
                    .by_ref()
                    .take_while(|x| !matches!(x.as_slice(), ['`', '`', '`', ..]))
                {
                    linesInBlock.push(z);
                }

                println!("Found codeblock with contents {:?}", linesInBlock)
            }
            [regularText @ ..] => {}

            _ => {}
        }
    }
}
